package org.jpn.xucker.rcp.subplayer;


import org.eclipse.core.runtime.Preferences;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.GroupMarker;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.jface.action.Separator;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.ui.IWorkbenchActionConstants;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.actions.ActionFactory;
import org.eclipse.ui.actions.ActionFactory.IWorkbenchAction;
import org.eclipse.ui.application.IActionBarConfigurer;
import org.eclipse.ui.application.IWorkbenchConfigurer;
import org.eclipse.ui.application.IWorkbenchWindowConfigurer;
import org.eclipse.ui.application.WorkbenchAdvisor;

import org.jpn.xucker.rcp.subplayer.preferences.LayerPage;
import org.jpn.xucker.rcp.subplayer.views.SubView;






public class SubplayerWorkbenchAdvisor extends WorkbenchAdvisor {

    public void initialize(IWorkbenchConfigurer configurer) {
        super.initialize(configurer);
		configurer.setSaveAndRestore(false);
	}
    
    public String getInitialWindowPerspectiveId() {
     
        return SubplayerPerspective.ID;
    }
    
    public void preWindowOpen(IWorkbenchWindowConfigurer configurer) {
       
        
        super.preWindowOpen(configurer);
        
        configurer.setInitialSize(new Point(740, 740));
        configurer.setShowCoolBar(false);
        configurer.setShowStatusLine(true);
        configurer.setShowPerspectiveBar(false);
        configurer.setShowFastViewBars(true);
        configurer.setShowMenuBar(true);
        
//      configurer.getActionBarConfigurer().getStatusLineManager().add(new Tmp());
        
    }
    
    public class Tmp extends Action{
        
    }

    
    
    public void postWindowOpen(IWorkbenchWindowConfigurer configurer) {
       // AudioToolsPlugin.getDefault().init();
       
        
	}
    
    public boolean preWindowShellClose(IWorkbenchWindowConfigurer configurer) {
        
        Preferences store=SubplayerPlugin.getDefault().getPluginPreferences();
        SubView view=(SubView)PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().findView(SubView.ID);
		if(view!=null){
		    for(int i=0;i<4;i++){
		        Rectangle rect=view.getLayerBounds(i);
		        if(rect!=null){
		            store.setValue(LayerPage.BASE+"x_"+(i+1),rect.x);
		            store.setValue(LayerPage.BASE+"y_"+(i+1),rect.y);
		            store.setValue(LayerPage.BASE+"w_"+(i+1),rect.width);
		            store.setValue(LayerPage.BASE+"h_"+(i+1),rect.height);
		        }
		    }
		}
		
       /*
        * 
         MessageBox messageBox=new MessageBox(configurer.getWindow().getShell(),SWT.OK);
	    messageBox.setText("File Not Found");
	    messageBox.setMessage("File Not Found\n"+"");
	    messageBox.open();
	    */
	    return true;
	}
    
    
    public void fillActionBars(
    	    IWorkbenchWindow window,
    	    IActionBarConfigurer configurer,
    	    int flags) {
    	    super.fillActionBars(window, configurer, flags);
             if ((flags & FILL_MENU_BAR) != 0) {
    	        fillMenuBar(window, configurer);
    	    }
             
             
    	}
    
    
    private void fillMenuBar(
    	    IWorkbenchWindow window,
    	    IActionBarConfigurer configurer) {
    	    IMenuManager menuBar = configurer.getMenuManager();
    	  
    	    menuBar.add(createFileMenu(window));
    	    menuBar.add(createWindowMenu(window));
    	    menuBar.add(createHelpMenu(window));
    	}
    
    
    private MenuManager createHelpMenu(IWorkbenchWindow window) {
        
         //System.out.println(IWorkbenchActionConstants.HELP_START);
         	    MenuManager menu = new MenuManager(Messages.getString("help"), //$NON-NLS-1$
         	        "myhelp"); //if add other basic plugin.should change it.
         	    menu.add(new GroupMarker(IWorkbenchActionConstants.HELP_START));
         	   
         	    IWorkbenchAction action=ActionFactory.ABOUT.create(window);
         	   
         	   
         	    menu.add(action);
         	   
         	    menu.add(new GroupMarker(IWorkbenchActionConstants.MB_ADDITIONS));
         	   
         	    menu.add(new GroupMarker(IWorkbenchActionConstants.HELP_END));
         	    
         	    return menu;
         	}
    private MenuManager createWindowMenu(IWorkbenchWindow window) {
        
        
         	    MenuManager menu = new MenuManager(Messages.getString("window"), 
         	        IWorkbenchActionConstants.M_WINDOW);
         	   
         	    IWorkbenchAction action=
         	   ActionFactory.PREFERENCES.create(window);
         	   action.setText(Messages.getString("preferences"));
         	   menu.add(action);
         	   
         	 
         	    
         	    return menu;
         	}
    
    private MenuManager createFileMenu(IWorkbenchWindow window) {
        
        
         	    MenuManager menu = new MenuManager(Messages.getString("file"), 
         	        "myfile");
         	   
         	   menu.add(new GroupMarker(IWorkbenchActionConstants.FILE_START));
         	    
         	    
         	   menu.add(new GroupMarker(IWorkbenchActionConstants.MB_ADDITIONS));
         	  
         	   menu.add(new Separator());
         	  IWorkbenchAction action=
            	   ActionFactory.QUIT.create(window);
         	   action.setText(Messages.getString("quit")); 
         	   //
         	   menu.add(action);
        	 
        	    menu.add(new GroupMarker(IWorkbenchActionConstants.FILE_END));
         	 
         	    
         	    return menu;
         	}

    
}